% Homework 1
% In this homework you will implement some of the algorithms that we have
% covered in class. In particular, you will implement:
%
% i) matrix-vector multiplication functions using row and column 
% conventions
%   matvecC.m  (5 points)
%   matvecFortran.m (5 points)  
% ii) Matrix-matrix multiplication function 
%   matmat. m (10 points)
% iii) A function that solves a linear sysmte using the row reduction
% algorithm  
%   solveLinearSystem.m (25 points)
%
% Moreover, you will time your matrix-vector multiplication functions to
% see which one is faster. You can use the script below (5 points)


n = 1000;
nSamples = 100;
time = 0;
for ii = 1:nSamples 
    A = rand(n,n);
    b = rand(n,1);
    tic();
    y = matvec(A,b);
    time = time + toc();
end
fprintf('Average time is %d [s] \n', time/nSamples)


n = 1000;
nSamples = 100;
time = 0;
for ii = 1:nSamples 
    A = rand(n,n);
    b = rand(n,1);
    tic();
    y = matvecFortran(A,b);
    time = time + toc();
end
fprintf('Average time is %d [s] \n', time/nSamples)


n = 1000;
nSamples = 100;
time = 0;
for ii = 1:nSamples 
    A = rand(n,n);
    b = rand(n,1);
    tic();
    y = matvecC(A,b);
    time = time + toc();
end
fprintf('Average time is %d [s] \n', time/nSamples)

% please keep in mind that you need to complete the body of the functions with
% the interface provided. We will write a script to test your functions, if
% the interface is not the same, the tests will fail, and you will not receive
% any credit. 

% In order to help you understand the MATLAB syntax, you can start by looking at 
%   example.m
% which contains some basic MATLAB commands 
%   matvec.m
% contains a function that uses two nested loops to perform a matrix vector
% multiplication. 
% plotLinearTransformations2D.m
% function that plots the deformation of the unit circle as it transformed by 
% a matrix. 



