% set up the sizes

m = 10
n = 10

% create a vector mx1 full of zeros
x = zeros(m,1)
% create a vector nx1 full of ones
y = ones(n,1)

%% create a random vector (usefull shen testing algorithms)
x = rand(m,1)

%% access entries of x
x(1)

%% define an index
i = 5
% accees i-th element in x
x(i)

%% modify an entry of x
x(i) = 100

x

%% create a matrix (random)
A = rand(m,n)

%% create another index
j = 3

% access i,j index of A
A(i,j)
%% access a column
A(:,j)

%% access a row
A(i,:)

%% compute the inner product
% you can add a semicolon at the end so it doesn't show in the console

x = rand(m,1);
y = rand(m,1);

innerproduct = 0;
for i = 1:m
   innerproduct = innerproduct  + x(i)*y(i);
end

fprintf('Inner product is %d \n', innerproduct)

%% Row reduction 

A = [1 2 3; ...
     4 5 6; ...
     6 7 8] ;
 
 % we can transpose vectors 
 b = [ 4 7 9 ].'
 
 %obtainingthe size of A
 [m,n] = size(A)
 
 % computing augmented matrix
 
 B = [A b];
 
 for i = 2:m
     B(i,:) = B(i,:) - B(1,:)*B(i,1)
 end
 
 if (B(2,2) == 0 )
     fprintf('pivot equals to zero! either swap or finish \n ');
 end
 B(2,:) =  B(2,:)/B(2,2)
 
 for i = 3:m
     B(i,:) = B(i,:) - B(2,:)*B(i,2)
 end
 
 if (B(3,3) == 0 )
     fprintf('pivot equals to zero either swap or finish \n');
 end
 %% test for consistency
 
 for i = 1:m
     normrow = norm(B(i,1:n));
     if (normrow == 0) && (B(i,n+1)~= 0)
         fprintf('matrix is not consistent \n')
     end
 end
 
 
 